<?php

/*
 * This file is part of the Symfony package.
 *
 * (c) Fabien Potencier <fabien@symfony.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace ncc\ThirdParty\Symfony\uid\Factory;

use ncc\ThirdParty\Symfony\uid\Uuid;
use ncc\ThirdParty\Symfony\uid\UuidV1;
use ncc\ThirdParty\Symfony\uid\UuidV6;

class TimeBasedUuidFactory
{
    private string $class;
    private ?Uuid $node;

    public function __construct(string $class, Uuid $node = null)
    {
        $this->class = $class;
        $this->node = $node;
    }

    public function create(\DateTimeInterface $time = null): UuidV6|UuidV1
    {
        $class = $this->class;

        if (null === $time && null === $this->node) {
            return new $class();
        }

        return new $class($class::generate($time, $this->node));
    }
}
